/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.EventTime;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ExportApi {
    private ApiClient localVarApiClient;

    public ExportApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ExportApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for exportEntriesCsvGet
     * @param bbox Bounding Box (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call exportEntriesCsvGetCall(String bbox, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/export/entries.csv";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (bbox != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("bbox", bbox));
        }

        if (categories != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("categories", categories));
        }

        if (text != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("text", text));
        }

        if (ids != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("ids", ids));
        }

        if (tags != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("tags", tags));
        }

        if (status != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("status", status));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        final String[] localVarAccepts = {
            "text/csv"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call exportEntriesCsvGetValidateBeforeCall(String bbox, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = exportEntriesCsvGetCall(bbox, categories, text, ids, tags, status, limit, _callback);
        return localVarCall;

    }

    /**
     * Export places as CSV.
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  Contact details (email/phone) are only visible for users with the role _Admin_ or _Scout_.  Information about who created the current version (created_by) is only visible for users with the role _Admin_ or owners of this entry.  **Example**:  Export all entries in Germany: &#x60;/export/entries.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public String exportEntriesCsvGet(String bbox, String categories, String text, String ids, String tags, String status, Long limit) throws ApiException {
        ApiResponse<String> localVarResp = exportEntriesCsvGetWithHttpInfo(bbox, categories, text, ids, tags, status, limit);
        return localVarResp.getData();
    }

    /**
     * Export places as CSV.
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  Contact details (email/phone) are only visible for users with the role _Admin_ or _Scout_.  Information about who created the current version (created_by) is only visible for users with the role _Admin_ or owners of this entry.  **Example**:  Export all entries in Germany: &#x60;/export/entries.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<String> exportEntriesCsvGetWithHttpInfo(String bbox, String categories, String text, String ids, String tags, String status, Long limit) throws ApiException {
        okhttp3.Call localVarCall = exportEntriesCsvGetValidateBeforeCall(bbox, categories, text, ids, tags, status, limit, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Export places as CSV. (asynchronously)
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  Contact details (email/phone) are only visible for users with the role _Admin_ or _Scout_.  Information about who created the current version (created_by) is only visible for users with the role _Admin_ or owners of this entry.  **Example**:  Export all entries in Germany: &#x60;/export/entries.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param categories Comma-separated list of category identifiers. We currently use the following two: - Initiative (non-commercial): &#x60;2cd00bebec0c48ba9db761da48678134&#x60; - Company (commercial): &#x60;77b3c33a92554bcf8e8c2c86cedd6f6f&#x60;  (optional)
     * @param text  (optional)
     * @param ids  (optional)
     * @param tags  (optional)
     * @param status  (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call exportEntriesCsvGetAsync(String bbox, String categories, String text, String ids, String tags, String status, Long limit, final ApiCallback<String> _callback) throws ApiException {

        okhttp3.Call localVarCall = exportEntriesCsvGetValidateBeforeCall(bbox, categories, text, ids, tags, status, limit, _callback);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for exportEventsCsvGet
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call exportEventsCsvGetCall(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/export/events.csv";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (bbox != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("bbox", bbox));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (tag != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("tag", tag));
        }

        if (startMin != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("start_min", startMin));
        }

        if (startMax != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("start_max", startMax));
        }

        if (text != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("text", text));
        }

        if (createdBy != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("created_by", createdBy));
        }

        final String[] localVarAccepts = {
            "text/csv"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call exportEventsCsvGetValidateBeforeCall(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback _callback) throws ApiException {
        

        okhttp3.Call localVarCall = exportEventsCsvGetCall(bbox, limit, tag, startMin, startMax, text, createdBy, _callback);
        return localVarCall;

    }

    /**
     * Export events as CSV.
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  **Example**:  Export all events in Germany: &#x60;/export/events.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public String exportEventsCsvGet(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy) throws ApiException {
        ApiResponse<String> localVarResp = exportEventsCsvGetWithHttpInfo(bbox, limit, tag, startMin, startMax, text, createdBy);
        return localVarResp.getData();
    }

    /**
     * Export events as CSV.
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  **Example**:  Export all events in Germany: &#x60;/export/events.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<String> exportEventsCsvGetWithHttpInfo(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy) throws ApiException {
        okhttp3.Call localVarCall = exportEventsCsvGetValidateBeforeCall(bbox, limit, tag, startMin, startMax, text, createdBy, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Export events as CSV. (asynchronously)
     * The CSV export is only available for logged in users with the role _Admin_ or _Scout_.  This request supports the same paramaters as the corresponding search request.  **Example**:  Export all events in Germany: &#x60;/export/events.csv?bbox&#x3D;47.49,0.79,54.63,18.30&#x60; 
     * @param bbox Bounding Box (optional)
     * @param limit Maximum number of items to return or implicit/unlimited if unspecified. (optional)
     * @param tag Filter events by tags (optional)
     * @param startMin Filter events by &#x60;event.start&#x60; &gt;&#x3D; &#x60;start_min&#x60; (optional, default to null)
     * @param startMax Filter events by &#x60;event.start&#x60; &lt;&#x3D; &#x60;start_max&#x60; (optional, default to null)
     * @param text Filter events by textual terms. Hashtags starting with &#39;#&#39; will be extracted from the given text and handled as tag filters.  (optional)
     * @param createdBy The email address of the event creator. Requests with this parameter will be rejected without a valid API token!  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Successful response </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Access token is missing or invalid or the user has insufficient permissions </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call exportEventsCsvGetAsync(String bbox, Long limit, String tag, EventTime startMin, EventTime startMax, String text, String createdBy, final ApiCallback<String> _callback) throws ApiException {

        okhttp3.Call localVarCall = exportEventsCsvGetValidateBeforeCall(bbox, limit, tag, startMin, startMax, text, createdBy, _callback);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
